<template>
    <div>
        <div class="titulo">
            <div class="ruta">
                <v-breadcrumbs :items="breadcrumbs">
                <template v-slot:divider>
                    <v-icon>mdi-chevron-right</v-icon>
                </template>
                </v-breadcrumbs>
            </div>
            <strong>Administrador de Visitas</strong>
        </div>
        
        <div class="contSecc">
            <v-btn color="primary" dark @click="showDialog">
                <v-icon color ='black' style="paddingLeft: 15px" small left>mdi-plus</v-icon><strong>Nueva visita</strong>
            </v-btn>
            <v-row >
                <v-col>
                    <v-sheet height="64">
                        <v-toolbar flat color="white">
                                <v-btn outlined text medium color="grey darken-2" @click="prev(); initRangoSemana()" class="btnRadius_L">
                                    <v-icon small>mdi-chevron-left</v-icon>
                                </v-btn>
                                <v-btn outlined text medium color="grey darken-2" @click="next(); initRangoSemana()" class="btnRadius_R" >
                                    <v-icon small>mdi-chevron-right</v-icon>
                                </v-btn>
                                <v-spacer></v-spacer>
                                <v-toolbar-title style="margin: 15px">
                                    SEMANA 
                                </v-toolbar-title>
                                <v-spacer></v-spacer>

                                <v-btn color="#fff" class ="btnRadius_L" style="padding: 0px 30px 0px 30px;" @click="goToMes()">
                                    <strong>Mes</strong>
                                </v-btn>
                                <v-btn color="primary" class = "btnRadius_NO" style="padding: 0px 30px 0px 30px;" @click="goToSemana()">
                                    <strong>Semana</strong>
                                </v-btn>            
                                <v-btn color="#fff" class ="btnRadius_R" style="padding: 0px 30px 0px 30px; "  @click="goToDay()">
                                    <strong>Dia</strong>
                                </v-btn>
                            </v-toolbar>
                        </v-sheet>
                        <v-sheet  outlined height="600" width="98%"  style="overflow-y : auto; overflow-x : hidden;">
                            <v-simple-table class="tblSemana">
                                <template v-slot:default>
                                    <thead>
                                        <tr style="background-color: #F9E79F;" >
                                            <th style="text-align : center;">
                                                Lunes
                                            </th>        
                                            <th style="text-align : center">
                                                Martes
                                            </th>      
                                            <th style="text-align : center">
                                                Miercoles
                                            </th>       
                                            <th style="text-align : center">
                                                Jueves
                                            </th>
                                            <th style="text-align : center">
                                                Viernes
                                            </th> 
                                            <th style="text-align : center">
                                                Sabado
                                            </th>
                                            <th style="text-align : center">
                                                Domingo
                                            </th> 
                                        </tr>                        
                                    </thead>
                                    <tbody >
                                        <tr>
                                            <td  v-for="(dia,indexDia) in diasSemana"
                                                :key="indexDia" style="text-align : center; width : 13% ; " >
                                                <div style="height : 98%; margin-top: 2%;">
                                                    <strong> {{dia.numeroDia}} </strong>
                                                    
                                                    <v-row  :v-if="getArrayAsignaciones(dia.fecha).length > 0" v-for="(evento, eventoIndex) in getArrayAsignaciones(dia.fecha)" :key='eventoIndex'
                                                        style="text-align: initial;  border-bottom: 1px solid gray; height:150px"
                                                    >
                                                        <v-col style="width:100%; ">
                                                            <v-icon :color ="getColor(evento.idNegocio)"  x-small left>mdi-checkbox-blank-circle</v-icon> {{evento.negocio}} - {{getNumEco(evento.idCeco)}}
                                                            <p>{{evento.nombreFase}} ({{evento.nombreProyecto}})</p>
                                                            {{evento.ceco}}
                                                            <p>{{evento.nombreResponsable}} </p>
                                                        </v-col>
                                                    
                                                    </v-row>
                                                    
                                                </div> 
                                                

                                            </td>

                                        </tr>

                                        <tr>
                                            
                                        </tr>                                    
                                    </tbody>
                                </template>
                            </v-simple-table>
                        </v-sheet>

                    </v-col>
                </v-row>

            <dialog-asignacion 
                ref="dialogAsingacionRef"
            >
            </dialog-asignacion>

            <simbologias></simbologias>
        </div>

        
    </div>

</template>
<script>
import router from "@/router";
import store from "@/store";
import DialogAsignacion from '@/views/secure/infraestructura/asignaciones/DialogAsignacion'
import Simbologias from '@/views/secure/infraestructura/components/Simbologias';
import moment from "moment";
const serviceCommons = store.state.serviceCommons;
export default {
    components:{
        DialogAsignacion,
        Simbologias
    },
    data() {

        return {
            breadcrumbs: [
                {
                    text: "Plataforma de Franquicia",
                    disabled: false,
                    exact: true,
                    to: {
                        name: "home"
                    }
                },
                {
                    text: "Infraestructura",
                    disabled: false,
                    exact: true,
                    to: {
                        name: "home"
                    }
                },
                {
                    text: "Asignación de Visita",
                    disabled: false,
                    exact: true,
                    to: {
                        name: "modelo_franquicia_info_recorridos"
                    }
                }
            ],
            asignaciones  : [],
            asignacionesSemanales : [],
            diasSemana : [],
            firstday : "",
            lastday: "",
            curr : null 
        }
    },
    created() {
        
        
        const dataTransfer = serviceCommons.base64ToObject(this.$route.params.dataTransfer);

        this.asignaciones  = dataTransfer.asignaciones;

        var curr = new Date; // get current date
        var first = curr.getDate() - curr.getDay(); // First day is the day of the month - the day of the week
        var last = first + 6; // last day is the first day + 6

        this.firstday = moment(new Date(curr.setDate(first))).add(1 ,"day").format('YYYY-MM-DD');
        this.lastday = moment(new Date(curr.setDate(last))).add(1 ,"day").format('YYYY-MM-DD');

        this.initRangoSemana();    
    
    },
    methods: {
        goToMes(){
            router.push({
                name : "modelo_franquicia_asignacion_adm_asigna",
                
            });
        },
        goToDay(){
            var today = moment(new Date()).format('YYYY-MM-DD');
            
            var objToPass = {
            dia : today,
            eventos : this.asignaciones  
            };
            
            router.push({
                name : "modelo_franquicia_calendario_diario",
                params : {
                dataTransfer : serviceCommons.objectToBase64(objToPass)
                }
            });
        },
        goToSemana (){
            var objToPass = {
            asignaciones : this.asignaciones  
            };

            router.push({
                name : "modelo_franquicia_calendario_semana",
                params : {
                dataTransfer : serviceCommons.objectToBase64(objToPass)
                }
            });
            
        },
        prev(){
            var auxDate = new Date(this.firstday);
            var nextWeek = moment(auxDate).subtract(6,"day").format('YYYY-MM-DD');
            this.firstday = nextWeek;
        },
        next(){
            var auxDate = new Date(this.firstday);
            var lastWeek = moment(auxDate).add(8,"day").format('YYYY-MM-DD');
            this.firstday = lastWeek;
        },
        getNumEco(ceco){
            var res = (""+ceco).substring(2); 
            return res
        },
        showDialog() {
            this.$refs.dialogAsingacionRef.showDialog();
        },
        initRangoSemana(){


            this.diasSemana = [];

            var firstDate = new Date(this.firstday);


            var fechaAux = null;

            for(var i = 1; i <= 7 ; i++){

                fechaAux = moment(firstDate).add(i,"day").format("YYYY-MM-DD");

                let objDia = {
                    fecha : fechaAux,
                    numeroDia : moment(new Date(fechaAux)).add(1,"day").format('DD'),
                    asignaciones : this.getEventosDia(fechaAux)
                }

                this.diasSemana.push(objDia);

            }

            
        },
        getArrayAsignaciones(fecha){

            let array = [];

            Object.keys(this.diasSemana).forEach(key =>{
                
                var asignacion = this.diasSemana[key];   

                console.log(JSON.stringify(asignacion))
                if(asignacion.fecha == fecha){
                    array = asignacion.asignaciones;
                }

            });

            console.log(JSON.stringify(array));


            return array;
            
        },
        getEventosDia(fecha){

            let asignacionesDia = [];

            Object.keys(this.asignaciones).forEach(key =>{
                
                var asignacion = this.asignaciones[key];    

                if(asignacion.start == fecha){
                    asignacionesDia.push(asignacion);
                }

            });

            return asignacionesDia;

        },
        getColor(negocio){
            var color  = "#000";

            console.log("EL negocio a validar es: "+negocio)

            if(negocio == "21"){
                color = "primary";
            }else if(negocio == "23"){
                color = "#191970";
            }else if(negocio == "25"){
                color = "#32CD32";
            }else if(negocio == "26"){
                color = "#F39C12";
            }

            return color;

        }
    },

}
</script>
<style scoped>
  

 .tblSemana{
     width: 100%; 
    

         
 } 
 .tblSemana tr:hover td {    background-color: #fff;}

.tblSemana tr td {
    font-size: 13px;
    text-align: center; 
    border-left: 1px solid gray;   


    
}

.v-data-table > .v-data-table__wrapper{

    overflow: hidden;
}
</style>